/**
 * Autogenerated by Avro
 *
 * DO NOT EDIT DIRECTLY
 */
package com.example.dto.avro;

import org.apache.avro.specific.SpecificData;
import org.apache.avro.message.BinaryMessageEncoder;
import org.apache.avro.message.BinaryMessageDecoder;
import org.apache.avro.message.SchemaStore;

@SuppressWarnings("all")
@org.apache.avro.specific.AvroGenerated
public class DemoTestDTO extends org.apache.avro.specific.SpecificRecordBase implements org.apache.avro.specific.SpecificRecord {
  private static final long serialVersionUID = -3356790556995440642L;
  public static final org.apache.avro.Schema SCHEMA$ = new org.apache.avro.Schema.Parser().parse("{\"type\":\"record\",\"name\":\"DemoTestDTO\",\"namespace\":\"com.example.dto.avro\",\"fields\":[{\"name\":\"id\",\"type\":\"long\"},{\"name\":\"info\",\"type\":\"string\"}]}");
  public static org.apache.avro.Schema getClassSchema() { return SCHEMA$; }

  private static SpecificData MODEL$ = new SpecificData();

  private static final BinaryMessageEncoder<DemoTestDTO> ENCODER =
      new BinaryMessageEncoder<DemoTestDTO>(MODEL$, SCHEMA$);

  private static final BinaryMessageDecoder<DemoTestDTO> DECODER =
      new BinaryMessageDecoder<DemoTestDTO>(MODEL$, SCHEMA$);

  /**
   * Return the BinaryMessageDecoder instance used by this class.
   */
  public static BinaryMessageDecoder<DemoTestDTO> getDecoder() {
    return DECODER;
  }

  /**
   * Create a new BinaryMessageDecoder instance for this class that uses the specified {@link SchemaStore}.
   * @param resolver a {@link SchemaStore} used to find schemas by fingerprint
   */
  public static BinaryMessageDecoder<DemoTestDTO> createDecoder(SchemaStore resolver) {
    return new BinaryMessageDecoder<DemoTestDTO>(MODEL$, SCHEMA$, resolver);
  }

  /** Serializes this DemoTestDTO to a ByteBuffer. */
  public java.nio.ByteBuffer toByteBuffer() throws java.io.IOException {
    return ENCODER.encode(this);
  }

  /** Deserializes a DemoTestDTO from a ByteBuffer. */
  public static DemoTestDTO fromByteBuffer(
      java.nio.ByteBuffer b) throws java.io.IOException {
    return DECODER.decode(b);
  }

  @Deprecated public long id;
  @Deprecated public java.lang.CharSequence info;

  /**
   * Default constructor.  Note that this does not initialize fields
   * to their default values from the schema.  If that is desired then
   * one should use <code>newBuilder()</code>.
   */
  public DemoTestDTO() {}

  /**
   * All-args constructor.
   * @param id The new value for id
   * @param info The new value for info
   */
  public DemoTestDTO(java.lang.Long id, java.lang.CharSequence info) {
    this.id = id;
    this.info = info;
  }

  public org.apache.avro.Schema getSchema() { return SCHEMA$; }
  // Used by DatumWriter.  Applications should not call.
  public java.lang.Object get(int field$) {
    switch (field$) {
    case 0: return id;
    case 1: return info;
    default: throw new org.apache.avro.AvroRuntimeException("Bad index");
    }
  }

  // Used by DatumReader.  Applications should not call.
  @SuppressWarnings(value="unchecked")
  public void put(int field$, java.lang.Object value$) {
    switch (field$) {
    case 0: id = (java.lang.Long)value$; break;
    case 1: info = (java.lang.CharSequence)value$; break;
    default: throw new org.apache.avro.AvroRuntimeException("Bad index");
    }
  }

  /**
   * Gets the value of the 'id' field.
   * @return The value of the 'id' field.
   */
  public java.lang.Long getId() {
    return id;
  }

  /**
   * Sets the value of the 'id' field.
   * @param value the value to set.
   */
  public void setId(java.lang.Long value) {
    this.id = value;
  }

  /**
   * Gets the value of the 'info' field.
   * @return The value of the 'info' field.
   */
  public java.lang.CharSequence getInfo() {
    return info;
  }

  /**
   * Sets the value of the 'info' field.
   * @param value the value to set.
   */
  public void setInfo(java.lang.CharSequence value) {
    this.info = value;
  }

  /**
   * Creates a new DemoTestDTO RecordBuilder.
   * @return A new DemoTestDTO RecordBuilder
   */
  public static com.example.dto.avro.DemoTestDTO.Builder newBuilder() {
    return new com.example.dto.avro.DemoTestDTO.Builder();
  }

  /**
   * Creates a new DemoTestDTO RecordBuilder by copying an existing Builder.
   * @param other The existing builder to copy.
   * @return A new DemoTestDTO RecordBuilder
   */
  public static com.example.dto.avro.DemoTestDTO.Builder newBuilder(com.example.dto.avro.DemoTestDTO.Builder other) {
    return new com.example.dto.avro.DemoTestDTO.Builder(other);
  }

  /**
   * Creates a new DemoTestDTO RecordBuilder by copying an existing DemoTestDTO instance.
   * @param other The existing instance to copy.
   * @return A new DemoTestDTO RecordBuilder
   */
  public static com.example.dto.avro.DemoTestDTO.Builder newBuilder(com.example.dto.avro.DemoTestDTO other) {
    return new com.example.dto.avro.DemoTestDTO.Builder(other);
  }

  /**
   * RecordBuilder for DemoTestDTO instances.
   */
  public static class Builder extends org.apache.avro.specific.SpecificRecordBuilderBase<DemoTestDTO>
    implements org.apache.avro.data.RecordBuilder<DemoTestDTO> {

    private long id;
    private java.lang.CharSequence info;

    /** Creates a new Builder */
    private Builder() {
      super(SCHEMA$);
    }

    /**
     * Creates a Builder by copying an existing Builder.
     * @param other The existing Builder to copy.
     */
    private Builder(com.example.dto.avro.DemoTestDTO.Builder other) {
      super(other);
      if (isValidValue(fields()[0], other.id)) {
        this.id = data().deepCopy(fields()[0].schema(), other.id);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.info)) {
        this.info = data().deepCopy(fields()[1].schema(), other.info);
        fieldSetFlags()[1] = true;
      }
    }

    /**
     * Creates a Builder by copying an existing DemoTestDTO instance
     * @param other The existing instance to copy.
     */
    private Builder(com.example.dto.avro.DemoTestDTO other) {
            super(SCHEMA$);
      if (isValidValue(fields()[0], other.id)) {
        this.id = data().deepCopy(fields()[0].schema(), other.id);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.info)) {
        this.info = data().deepCopy(fields()[1].schema(), other.info);
        fieldSetFlags()[1] = true;
      }
    }

    /**
      * Gets the value of the 'id' field.
      * @return The value.
      */
    public java.lang.Long getId() {
      return id;
    }

    /**
      * Sets the value of the 'id' field.
      * @param value The value of 'id'.
      * @return This builder.
      */
    public com.example.dto.avro.DemoTestDTO.Builder setId(long value) {
      validate(fields()[0], value);
      this.id = value;
      fieldSetFlags()[0] = true;
      return this;
    }

    /**
      * Checks whether the 'id' field has been set.
      * @return True if the 'id' field has been set, false otherwise.
      */
    public boolean hasId() {
      return fieldSetFlags()[0];
    }


    /**
      * Clears the value of the 'id' field.
      * @return This builder.
      */
    public com.example.dto.avro.DemoTestDTO.Builder clearId() {
      fieldSetFlags()[0] = false;
      return this;
    }

    /**
      * Gets the value of the 'info' field.
      * @return The value.
      */
    public java.lang.CharSequence getInfo() {
      return info;
    }

    /**
      * Sets the value of the 'info' field.
      * @param value The value of 'info'.
      * @return This builder.
      */
    public com.example.dto.avro.DemoTestDTO.Builder setInfo(java.lang.CharSequence value) {
      validate(fields()[1], value);
      this.info = value;
      fieldSetFlags()[1] = true;
      return this;
    }

    /**
      * Checks whether the 'info' field has been set.
      * @return True if the 'info' field has been set, false otherwise.
      */
    public boolean hasInfo() {
      return fieldSetFlags()[1];
    }


    /**
      * Clears the value of the 'info' field.
      * @return This builder.
      */
    public com.example.dto.avro.DemoTestDTO.Builder clearInfo() {
      info = null;
      fieldSetFlags()[1] = false;
      return this;
    }

    @Override
    @SuppressWarnings("unchecked")
    public DemoTestDTO build() {
      try {
        DemoTestDTO record = new DemoTestDTO();
        record.id = fieldSetFlags()[0] ? this.id : (java.lang.Long) defaultValue(fields()[0]);
        record.info = fieldSetFlags()[1] ? this.info : (java.lang.CharSequence) defaultValue(fields()[1]);
        return record;
      } catch (java.lang.Exception e) {
        throw new org.apache.avro.AvroRuntimeException(e);
      }
    }
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumWriter<DemoTestDTO>
    WRITER$ = (org.apache.avro.io.DatumWriter<DemoTestDTO>)MODEL$.createDatumWriter(SCHEMA$);

  @Override public void writeExternal(java.io.ObjectOutput out)
    throws java.io.IOException {
    WRITER$.write(this, SpecificData.getEncoder(out));
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumReader<DemoTestDTO>
    READER$ = (org.apache.avro.io.DatumReader<DemoTestDTO>)MODEL$.createDatumReader(SCHEMA$);

  @Override public void readExternal(java.io.ObjectInput in)
    throws java.io.IOException {
    READER$.read(this, SpecificData.getDecoder(in));
  }

}
